'''
Aufgabe 3
'''
import matplotlib.pyplot as plt
import matplotlib.colors as colors
import numpy as np
import math
import pgm



def createBandrejectFilter(w, h, d0, weight):
    
    result = np.zeros((h, w))
     
    for y in xrange(h):
        for x in xrange(w):
            y2 = y - h / 2
            x2 = x - w / 2
            d = math.sqrt(y2 * y2 + x2 * x2)
            #result[y, x] = 1 - math.exp(-math.pow((d * d - d0*d0) / ((d + 0.00001) * weight), 2))
            if d0 - weight/2 <= d and d <= d0 + weight/2 : 
                result[y, x] = 0
            else :
                result[y, x] = 1
           
    return result



def createLowPassFilter(w, h, a, d0):
    
    result = np.zeros((h, w))
    
    for y in xrange(h):
        for x in xrange(w):
            y2 = y - h / 2
            x2 = x - w / 2
            d = math.sqrt(y2 * y2 + x2 * x2)
            result[y, x] = a + (1 - a) * math.exp(-d * d / (2 * d0 * d0))
    return result



def applyFilter(image, filter):
    
    result = image * filter
    
    return result



def getAmplitudeImage(image):
    
    result = np.array([[math.sqrt(v.real * v.real + v.imag * v.imag) for v in row] for row in image])
    result = np.log(1 + result)
    return result



def aufgabe2():
    
    image = pgm.imread("whoIsThis.pgm")
    
    imageFT = np.fft.fft2(image)
    imageFTShift = np.fft.fftshift(imageFT)
    imageFTAmp = getAmplitudeImage(imageFTShift)
    
    filter = createBandrejectFilter(image.shape[1], image.shape[0], 50, 1.25)
    resultFT = applyFilter(imageFTShift, filter)
    resultFTAmp = getAmplitudeImage(resultFT)
    
    result = np.fft.ifftshift(resultFT)
    result = np.fft.ifft2(result)
    result = result.real
    
    filter2 = 1/createLowPassFilter(image.shape[1], image.shape[0], 0.001, 15)
    result2FT = applyFilter(resultFT, filter2)
    result2FTAmp = getAmplitudeImage(result2FT)
    
    result2 = np.fft.ifftshift(result2FT)
    result2 = np.fft.ifft2(result2)
    result2 = result2.real
    
    plt.figure(1)
    plt.subplot(241)
    plt.imshow(image, cmap=plt.cm.gray)
    plt.subplot(242)
    plt.imshow(imageFTAmp, cmap=plt.cm.gray)
    plt.subplot(243)
    plt.imshow(filter, cmap=plt.cm.gray)
    plt.subplot(244)
    plt.imshow(resultFTAmp, cmap=plt.cm.gray)
    plt.subplot(245)
    plt.imshow(result, cmap=plt.cm.gray)
    plt.subplot(246)
    plt.imshow(filter2, cmap=plt.cm.gray)
    plt.subplot(247)
    plt.imshow(result2FTAmp, cmap=plt.cm.gray)
    plt.subplot(248)
    plt.imshow(result2, cmap=plt.cm.gray)
    plt.show()
    

aufgabe2()
